;---8<-------------------------[r_gen32.asm]-------------------------------8<--;
;                                                                              ;
;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx;
;                       [RANDOM IN RANGE GENERATOR V. 0.2]                     ;
;                                                                              ;
;    ############              #############   #############   ######    ###   ;
;    #############            ##############  ##############  ########   ###   ;
;    ##        ###            ###             ###             ###  ###   ###   ;
;    #############            ###  ########   ##############  ###  ###   ###   ;
;    #############            ###  #########  ##############  ###  ###   ###   ;
;    ##        ###            ###        ###  ###             ###  ###   ###   ;
;    ##        ###            ##############  ##############  ###  #########   ;
;    ##        ###  #########  ############    #############  ###   #######    ;
;                   #########                                                  ;
;                                                                              ;
;                               FOR MS WINDOWS                                 ;
;                                                                              ;
;                                   BY SL0N                                    ;
;------------------------------------------------------------------------------;
;                                   MANUAL:                                    ;
;                                                                              ;
; RANGE OF RANDOM NUMBER -> EAX                          		       ;
; CALL  BRANDOM32           			       			       ;
;									       ;
; RANDOM NUMBER IN RANGE -> EAX                          		       ;
;------------------------------------------------------------------------------;
; (+) EASY TO USE                                                              ;
; (+) DO NOT USE WIN API                                                       ;
;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx;
brandom32:					   ;   
						   ;   
						   ;   0..eax-1

		call	delta2                     ;
delta2:		pop	ebp                        ;   
		sub	ebp,offset delta2          ;

		push	edx ecx                    ;    edx, ecx
		xor	edx,edx                    ;  edx
		imul	eax,eax,100                ;  eax  100
		push	eax                        ;   eax  
		call	random32                   ;  
						   ;   
		pop	ecx                        ;  
						   ;    ecx
		div	ecx                        ;  eax  ecx
		xchg	eax,edx                    ;    eax
		xor	edx,edx                    ;  edx
		mov	ecx,100                    ;   ecx - 100
		div	ecx                        ;  eax  ecx
		pop	ecx edx                    ;  ecx, edx
		ret                                ;   
;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx;
;			RANDOM NUMBER GENERATOR SUBROUTINE		       ;
;------------------------------------------------------------------------------;
;			           [ IN ]				       ;
;                                                                              ;
;          		     NO INPUT IN SUBROTINE                             ;
;------------------------------------------------------------------------------;
;			           [ OUT ]				       ;
;									       ;
;               	     RANDOM NUMBER -> EAX                              ;
;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx;
random32:                                          
						   ;   

		push	edx ecx                    ;    edx, ecx
		db	0fh,031h                   ;  rdtsc
		rcl	eax,2                      ;   
		add	eax,12345678h              ; 
		random_seed = dword ptr $-4        ; 
		adc	eax,esp                    ;  , 
		xor	eax,ecx                    ;    
		xor	[ebp+random_seed], eax     ; 
		add	eax,[esp-8]                ;
		rcl	eax,1                      ;
		pop	ecx edx                    ;  ecx, edx
		ret                                ;   
;---8<-------------------------[r_gen32.asm]-------------------------------8<--;
